/**
    IoLanguageEngine
 
    @COPYRIGHT@
 
    Written by: @AUTHOR@
    Date: @DATE@
 
 */

#import "IoLanguageEngine.h"
#import "IoState.h"
#import "IoObjcBridge.h"
#import "Objc2Io.h"

/* Taken from IoBindingsInit.c generated from io language */
void IoBindingsInit(IoState *self, IoObject *context)
{
        IoAAVectorInit(self, context);
        IoObjcBridgeInit(self, context);
}

@implementation IoLanguageEngine

- (id)interpretScript:(NSString *)script
            inContext:(STContext *)context
{
    IoObject *result;
    IoState *state = IoState_new();
    IoState_setBindingsInitCallback(state, (IoStateBindingsInitCallback *)IoBindingsInit);
    IoState_init(state);
    result = IoState_doCString_(state, [script cString]);

    IoObjcBridge *bridge = IoObjcBridge_sharedBridge();
    char type = '@'; /* For objc object */
    char *error;
    void *cValue = IoObjcBridge_cValueForIoObject_ofType_error_(bridge, result, &type, &error);
    if (error) {
      return [NSString stringWithCString: error encoding: NSASCIIStringEncoding];
    } else {
#if 0
      return NSStringFromClass([*(id*)cValue class]);
      return [NSString stringWithFormat: @"%p", cValue];
#endif
      return *(id*)cValue;
    }
    return @"Io language: Failed";
}

@end
